#<profile4xi profile = "10" />
# -------------------------------------------------------------------------------------------------
#<program4xi program = "loop4xi.py">
#<abstract4xi abstract = "provides loop services"/>
#<refer4xi reference = "yourDragon4Xi"/>
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting; [Rel 7.21]"/>
# -------------------------------------------------------------------------------------------------

# ------------------------------------------------------------------------------------------------- 
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'limit2loop4xi' ]
#"
#/>

# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os
import sys
import threading                
import _thread
import _winapi
   

import datetime
import time
from time import gmtime, strftime
#"
#/>
# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
try:                 # system ones
    import os
    import sys
    import signal
except:
    pass
try:                 # threading ones       
    import threading                
    import _thread   
except:
    pass
try:                 # most-common ones
    import time         
    from time import gmtime, strftime 
except:
    pass
try:                 # rare ones
    import datetime
except:
    pass 
       
#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "
from cpu_corecount4xi import cpu_corecount4xi
from reason_object4xi import reason_object4xi
from sense_object4xi import sense_object4xi
from timeouterror4xi import TimeoutError4Xi
from print4xi import print4xi
from time4xi import time4xi        
#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi Globals                            
# ------------------------------------------------------------------------------------------------
#<globalize4xi globalization = "
global KB4Loop
global default2loop 
#"
#/>



# -------------------------------------------------------------------------------------------------
# Settings (seconds - 0.01seconds equals to 10ms)
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "
KB4Loop = { 'answer_challenge4xi2answer_challenge4xi': cpu_corecount4xi() * 2,
            
            'ApplyResult4Xi2successful': cpu_corecount4xi() * 2, 
            'ApplyResult4Xi2wait': cpu_corecount4xi() * 2,             
            
            'deliver_challenge4xi2deliver_challenge4xi': cpu_corecount4xi() * 2,
            
            'PipeClient4Xi2PipeClient4Xi': cpu_corecount4xi() * 2,                
            
            'PipeListener4Xi2__init__': cpu_corecount4xi() * 2,
            
            'Popen4Xi2wait': cpu_corecount4xi() * 2, 
            
            'SyncManager4Xi2get_server': cpu_corecount4xi() * 2, 
            'SyncManager4Xi2connect': cpu_corecount4xi() * 2, 
            'SyncManager4Xi2start': cpu_corecount4xi() * 2}   
                                                                 

                 
             
default2loop = cpu_corecount4xi() * 2  # maximum trials in loops
#"
#"/>
 


# -------------------------------------------------------------------------------------------------
#<function4xi function = "limit2loop4xi" usage = "
#   provides services to adjust loop maximums in the system by tuning one module
#   example:
#       popen4xi.py:
#           Popen4Xi:
#               wait:
#                   max2count = limit2loop4xi(class2print, method2print)
#                   while ((count2try < max2count) and (nack2response is True)): 
#               
#"> 
#<state4xi status = "ACK4review; ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------
def limit2loop4xi (class2loop, method2loop):
    '''
    loops milliseconds to the caller based on given class and method
    '''
    global KB4Loop
    global default2loop 
       
    # ---------------------------------------------------------------------------------------------    
    #
    # ---------------------------------------------------------------------------------------------     
    class2print = 'limit2loop4xi'
    method2print = 'limit2loop4xi'
    
    message2print = "{started" + "; limit2loop4xi-started: " + str(limit2loop4xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print) 
    #HW: <function limit2loop4xi at 0x02BCC780>; time: 04:06:51 04/24/10 Pacific Daylight Time
        
    message2print = "{passed" + "; class2loop-passed-to-limit2loop4xi: " + str(class2loop) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)  
    #HW: Popen4Xi; time: 04:06:51 04/24/10 Pacific Daylight Time
        
    message2print = "{passed" + "; method2loop-passed-to-limit2loop4xi: " + str(method2loop) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)  
    #HW: wait; time: 04:06:51 04/24/10 Pacific Daylight Time
                    
            
    keys2KB = KB4Loop.keys()
   
    key2caller = str(class2loop) + "2" + str(method2loop)

    message2print = "{set" + "; key2caller-set-by-limit2loop4xi to: " + str(key2caller)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)  
    #HW: Popen4Xi2wait; time: 04:06:51 04/24/10 Pacific Daylight Time
            
        
    loop2xi = default2loop
    
    # ---------------------------------------------------------------------------------------------    
    #
    # ---------------------------------------------------------------------------------------------     

    for key2xi in sorted(keys2KB):
        if key2xi == key2caller:
            loop2xi = KB4Loop[key2caller]
            
            message2print = "{tuned" + "; loop2xi-tuned-by-limit2loop4xi: " + str(loop2xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            #HW: 8; time: 04:06:51 04/24/10 Pacific Daylight Time
            
                    
            break
        else:
            pass
               

    # ---------------------------------------------------------------------------------------------    
    #
    # ---------------------------------------------------------------------------------------------     
    message2print = "{returning" + "; loop2xi-returning-by-limit2loop4xi: " + str(loop2xi) + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)   
    #HW: 8; time: 04:06:51 04/24/10 Pacific Daylight Time
        
        
        
    return loop2xi              
        
        
    
#</function4xi>
#</program4xi>


# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "

#  hellow_world4xi.txt
#  sense-hello-world4xi.xml
#  reason-hello-world4xi.xml
#  ace-hello-world4xi.xml
#"
#/>

# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of loop4xi.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>
